// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: sim_util.h 741 2007-08-14 02:39:19Z ctsa $

/// \file

#ifndef __SIM_UTIL_H
#define __SIM_UTIL_H

#include "subs_ml_model.h"
#include "site_data.h"

#include <vector>

struct rate_gtor_base;
struct sim_options;
struct subs_ml_model;


extern const smlfloat SIMULATE_DISCRETE_TIME_UNIT;


void
get_ancestral_seq(const subs_ml_model& mdl,
                  const unsigned size,
                  const std::vector<unsigned>& site_cats,
                  std::vector<unsigned>& seq);

void
get_sim_site_categories(std::vector<unsigned>& cats,
                        const unsigned size,
                        const rate_gtor_base& rg);

void
sim_site_data_init(const bi_tree_sml_type& tree,
                   const RATE_GTOR_MODEL::index_t rgm,
                   site_data& sd);

#endif
