// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: site_data_fastlup_util.h 741 2007-08-14 02:39:19Z ctsa $

/// \file

#ifndef __SITE_DATA_FASTLUP_UTIL_H
#define __SITE_DATA_FASTLUP_UTIL_H

#include "site_data_fastlup.h"
#include "catmap_util.h"

struct bi_tree_sml_type;
struct site_data;

///  catmap is f(data_cat_label)->(model_cat_num | (max_model_cat_no+1))
///
void
site_data_to_site_data_fastlup(const bi_tree_sml_type& tree,
                               const site_data& sd,
                               const unsigned n_states,
                               const unsigned n_model_site_cats,
                               const data_catmap_type& catmap,
                               site_data_fastlup& sdf);

void
site_data_fastlup_state_reduction(const bi_tree_sml_type& tree,
                                  const unsigned reduced_n_states,
                                  const site_data_fastlup& sdf_in,
                                  const unsigned* index_translation,
                                  site_data_fastlup& sdf_out);

#endif
