// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: subs_ml_model.hh 741 2007-08-14 02:39:19Z ctsa $

/// \file

template <typename OutputIterator>
OutputIterator
subs_ml_model::
is_train_param(OutputIterator i) const {

  i = get_time_gtor().is_train_param(i);
  i = get_rate_gtor().is_train_param(i);
  i = get_root_gtor().is_train_param(i);
  return i;
}




template <typename InputIterator>
InputIterator
subs_ml_model::
set_is_train_param(InputIterator i) {

  i = get_time_gtor().set_is_train_param(i);
  i = get_rate_gtor().set_is_train_param(i);
  i = get_root_gtor().set_is_train_param(i);
  return i;
}




template <typename OutputIterator>
OutputIterator
subs_ml_model::
param_state(OutputIterator x,
            const PARAM_VIEW::index_t pv) const {

  x = get_time_gtor().param_state(x,pv);
  x = get_rate_gtor().param_state(x,pv);
  x = get_root_gtor().param_state(x,pv);
  return x;
}




template <typename InputIterator>
InputIterator
subs_ml_model::
set_param_state(InputIterator x,
                const PARAM_VIEW::index_t pv,
                const bool is_secondary_update) {

  x = get_time_gtor().set_param_state(x,pv);
  x = get_rate_gtor().set_param_state(x,pv);
  x = get_root_gtor().set_param_state(x,pv,is_secondary_update);
  return x;
}
